"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const microservices_1 = require("@nestjs/microservices");
const common_1 = require("@nestjs/common");
const zeebe_constans_1 = require("../zeebe.constans");
const zeebe_node_next_1 = require("zeebe-node-next");
const process = require("process");
/**
 * A customer transport for Zeebe.
 *
 * @export
 * @class ZeebeServer
 * @extends {Server}
 * @implements {CustomTransportStrategy}
 */
let ZeebeServer = class ZeebeServer extends microservices_1.Server {
    constructor(client) {
        super();
        this.client = client;
    }
    listen(callback) {
        return __awaiter(this, void 0, void 0, function* () {
            this.init();
            callback();
        });
    }
    close() {
        this.client.close().then(() => console.log('All workers closed'));
    }
    init() {
        const handlers = this.getHandlers();
        handlers.forEach((value, key, map) => {
            let workerOptions = {
                id: '',
                taskType: '',
                handler: value,
                options: {},
                onConnectionError: undefined
            };
            let jsonKey = null;
            // See if it's a json, if so use it's data
            try {
                jsonKey = JSON.parse(key);
                workerOptions.taskType = jsonKey.type;
                workerOptions.options = jsonKey.options || {};
            }
            catch (ex) {
                workerOptions.taskType = key;
            }
            workerOptions.id = `${workerOptions.taskType}_${process.pid}`;
            const zbWorker = this.client.createWorker(workerOptions.id, workerOptions.taskType, workerOptions.handler, workerOptions.options);
        });
    }
};
ZeebeServer = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(zeebe_constans_1.ZEEBE_CONNECTION_PROVIDER)),
    __metadata("design:paramtypes", [zeebe_node_next_1.ZBClient])
], ZeebeServer);
exports.ZeebeServer = ZeebeServer;
